Index: /trunk/packages/vizservers/vtkvis/RpVtkRendererCmd.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/RpVtkRendererCmd.cpp	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/RpVtkRendererCmd.cpp	(revision 2423)
@@ -10,4 +10,6 @@
 #include <cstring>
 #include <cerrno>
+#include <string>
+#include <sstream>
 #include <unistd.h>
 #include <sys/uio.h>
@@ -24,4 +26,20 @@
 using namespace Rappture::VtkVis;
 
+static ssize_t
+SocketWrite(const void *bytes, size_t len)
+{
+    size_t ofs = 0;
+    ssize_t bytesWritten;
+    while ((bytesWritten = write(g_fdOut, (const char *)bytes + ofs, len - ofs)) > 0) {
+        ofs += bytesWritten;
+        if (ofs == len)
+            break;
+    }
+    if (bytesWritten < 0) {
+        ERROR("write: %s", strerror(errno));
+    }
+    return bytesWritten;
+}
+
 static int
 ExecuteCommand(Tcl_Interp *interp, Tcl_DString *dsPtr) 
@@ -35,5 +53,5 @@
 }
 
-static bool
+static int
 GetBooleanFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr, bool *boolPtr)
 {
@@ -47,5 +65,5 @@
 }
 
-int
+static int
 GetFloatFromObj(Tcl_Interp *interp, Tcl_Obj *objPtr, float *valuePtr)
 {
@@ -324,14 +342,9 @@
 
     char buf[256];
-    snprintf(buf, sizeof(buf), "nv>camera set %.12e %.12e %.12e %.12e %.12e %.12e %.12e %.12e %.12e", 
+    snprintf(buf, sizeof(buf), "nv>camera set %.12e %.12e %.12e %.12e %.12e %.12e %.12e %.12e %.12e\n", 
              pos[0], pos[1], pos[2], focalPt[0], focalPt[1], focalPt[2], viewUp[0], viewUp[1], viewUp[2]);
-    ssize_t bytesWritten;
-    size_t len = strlen(buf);
-    size_t ofs = 0;
-    while ((bytesWritten = write(g_fdOut, buf + ofs, len - ofs)) > 0) {
-        ofs += bytesWritten;
-        if (ofs == len)
-            break;
-    }
+
+    ssize_t bytesWritten = SocketWrite(buf, strlen(buf));
+
     if (bytesWritten < 0) {
         return TCL_ERROR;
@@ -361,14 +374,30 @@
               Tcl_Obj *const *objv)
 {
-    double x, y, width, height;
-
-    if (Tcl_GetDoubleFromObj(interp, objv[2], &x) != TCL_OK ||
-        Tcl_GetDoubleFromObj(interp, objv[3], &y) != TCL_OK ||
-        Tcl_GetDoubleFromObj(interp, objv[4], &width) != TCL_OK ||
-        Tcl_GetDoubleFromObj(interp, objv[5], &height) != TCL_OK) {
-        return TCL_ERROR;
-    }
-
-    g_renderer->setCameraZoomRegion(x, y, width, height);
+    const char *string = Tcl_GetString(objv[2]);
+
+    if (string[0] == 'p' && strcmp(string, "pixel") == 0) {
+        int x, y, width, height;
+        if (Tcl_GetIntFromObj(interp, objv[3], &x) != TCL_OK ||
+            Tcl_GetIntFromObj(interp, objv[4], &y) != TCL_OK ||
+            Tcl_GetIntFromObj(interp, objv[5], &width) != TCL_OK ||
+            Tcl_GetIntFromObj(interp, objv[6], &height) != TCL_OK) {
+            return TCL_ERROR;
+        }
+        g_renderer->setCameraZoomRegionPixels(x, y, width, height);
+    } else if (string[0] == 'w' && strcmp(string, "world") == 0) {
+        double x, y, width, height;
+        if (Tcl_GetDoubleFromObj(interp, objv[3], &x) != TCL_OK ||
+            Tcl_GetDoubleFromObj(interp, objv[4], &y) != TCL_OK ||
+            Tcl_GetDoubleFromObj(interp, objv[5], &width) != TCL_OK ||
+            Tcl_GetDoubleFromObj(interp, objv[6], &height) != TCL_OK) {
+            return TCL_ERROR;
+        }
+        g_renderer->setCameraZoomRegion(x, y, width, height);
+    } else {
+        Tcl_AppendResult(interp, "bad camera ortho option \"", string,
+                         "\": should be pixel or world", (char*)NULL);
+        return TCL_ERROR;
+    }
+
     return TCL_OK;
 }
@@ -466,5 +495,5 @@
     {"mode", 1, CameraModeOp, 3, 3, "mode"},
     {"orient", 3, CameraOrientOp, 6, 6, "qw qx qy qz"},
-    {"ortho", 1, CameraOrthoOp, 6, 6, "x y width height"},
+    {"ortho", 1, CameraOrthoOp, 7, 7, "coordMode x y width height"},
     {"pan", 1, CameraPanOp, 4, 4, "panX panY"},
     {"reset", 2, CameraResetOp, 2, 3, "?all?"},
@@ -625,7 +654,13 @@
     if (objc == 5) {
         const char *name = Tcl_GetString(objv[4]);
-        g_renderer->addContour2D(name, contourList);
-    } else {
-        g_renderer->addContour2D("all", contourList);
+        if (!g_renderer->addContour2D(name, contourList)) {
+            Tcl_AppendResult(interp, "Failed to create contour2d", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addContour2D("all", contourList)) {
+            Tcl_AppendResult(interp, "Failed to create contour2d for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -642,7 +677,13 @@
     if (objc == 5) {
         const char *name = Tcl_GetString(objv[4]);
-        g_renderer->addContour2D(name, numContours);
-    } else {
-        g_renderer->addContour2D("all", numContours);
+        if (!g_renderer->addContour2D(name, numContours)) {
+            Tcl_AppendResult(interp, "Failed to create contour2d", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+       if (!g_renderer->addContour2D("all", numContours)) {
+            Tcl_AppendResult(interp, "Failed to create contour2d for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+       }
     }
     return TCL_OK;
@@ -878,7 +919,13 @@
     if (objc == 5) {
         const char *name = Tcl_GetString(objv[4]);
-        g_renderer->addContour3D(name, contourList);
-    } else {
-        g_renderer->addContour3D("all", contourList);
+        if (!g_renderer->addContour3D(name, contourList)) {
+            Tcl_AppendResult(interp, "Failed to create contour3d", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addContour3D("all", contourList)) {
+            Tcl_AppendResult(interp, "Failed to create contour3d for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -895,7 +942,13 @@
     if (objc == 5) {
         const char *name = Tcl_GetString(objv[4]);
-        g_renderer->addContour3D(name, numContours);
-    } else {
-        g_renderer->addContour3D("all", numContours);
+        if (!g_renderer->addContour3D(name, numContours)) {
+            Tcl_AppendResult(interp, "Failed to create contour3d", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addContour3D("all", numContours)) {
+            Tcl_AppendResult(interp, "Failed to create contour3d for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -1290,6 +1343,6 @@
 
 static int
-DataSetGetValuePixelOp(ClientData clientData, Tcl_Interp *interp, int objc, 
-                       Tcl_Obj *const *objv)
+DataSetGetScalarPixelOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                        Tcl_Obj *const *objv)
 {
     const char *name = Tcl_GetString(objv[5]);
@@ -1299,15 +1352,15 @@
         return TCL_ERROR;
     }
-    double value = g_renderer->getDataValueAtPixel(name, x, y);
-    char buf[128];
-    snprintf(buf, sizeof(buf), "nv>dataset value pixel %d %d %.12e", x, y, value);
-    ssize_t bytesWritten;
-    size_t len = strlen(buf);
-    size_t ofs = 0;
-    while ((bytesWritten = write(g_fdOut, buf + ofs, len - ofs)) > 0) {
-        ofs += bytesWritten;
-        if (ofs == len)
-            break;
-    }
+    double value;
+    if (!g_renderer->getScalarValueAtPixel(name, x, y, &value)) {
+        Tcl_AppendResult(interp, "Pixel out of dataset bounds or no scalar data available", (char*)NULL);
+        return TCL_ERROR;
+    }
+
+    char buf[256];
+    snprintf(buf, sizeof(buf), "nv>dataset scalar pixel %d %d %g %s\n", x, y, value, name);
+
+    ssize_t bytesWritten = SocketWrite(buf, strlen(buf));
+
     if (bytesWritten < 0) {
         return TCL_ERROR;
@@ -1317,6 +1370,6 @@
 
 static int
-DataSetGetValueWorldOp(ClientData clientData, Tcl_Interp *interp, int objc, 
-                       Tcl_Obj *const *objv)
+DataSetGetScalarWorldOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                        Tcl_Obj *const *objv)
 {
     const char *name = Tcl_GetString(objv[6]);
@@ -1327,15 +1380,15 @@
         return TCL_ERROR;
     }
-    double value = g_renderer->getDataValue(name, x, y, z);
-    char buf[128];
-    snprintf(buf, sizeof(buf), "nv>dataset value world %.12e %.12e %.12e %.12e", x, y, z, value);
-    ssize_t bytesWritten;
-    size_t len = strlen(buf);
-    size_t ofs = 0;
-    while ((bytesWritten = write(g_fdOut, buf + ofs, len - ofs)) > 0) {
-        ofs += bytesWritten;
-        if (ofs == len)
-            break;
-    }
+    double value;
+    if (!g_renderer->getScalarValue(name, x, y, z, &value)) {
+        Tcl_AppendResult(interp, "Coordinate out of dataset bounds or no scalar data available", (char*)NULL);
+        return TCL_ERROR;
+    }
+
+    char buf[256];
+    snprintf(buf, sizeof(buf), "nv>dataset scalar world %g %g %g %g %s\n", x, y, z, value, name);
+
+    ssize_t bytesWritten = SocketWrite(buf, strlen(buf));
+
     if (bytesWritten < 0) {
         return TCL_ERROR;
@@ -1344,17 +1397,94 @@
 }
 
-static Rappture::CmdSpec dataSetGetValueOps[] = {
-    {"pixel", 1, DataSetGetValuePixelOp, 6, 6, "x y dataSetName"},
-    {"world", 1, DataSetGetValueWorldOp, 7, 7, "x y z dataSetName"}
+static Rappture::CmdSpec dataSetGetScalarOps[] = {
+    {"pixel", 1, DataSetGetScalarPixelOp, 6, 6, "x y dataSetName"},
+    {"world", 1, DataSetGetScalarWorldOp, 7, 7, "x y z dataSetName"}
 };
-static int nDataSetGetValueOps = NumCmdSpecs(dataSetGetValueOps);
-
-static int
-DataSetGetValueOp(ClientData clientData, Tcl_Interp *interp, int objc, 
-                  Tcl_Obj *const *objv)
+static int nDataSetGetScalarOps = NumCmdSpecs(dataSetGetScalarOps);
+
+static int
+DataSetGetScalarOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                   Tcl_Obj *const *objv)
 {
     Tcl_ObjCmdProc *proc;
 
-    proc = Rappture::GetOpFromObj(interp, nDataSetGetValueOps, dataSetGetValueOps,
+    proc = Rappture::GetOpFromObj(interp, nDataSetGetScalarOps, dataSetGetScalarOps,
+                                  Rappture::CMDSPEC_ARG2, objc, objv, 0);
+    if (proc == NULL) {
+        return TCL_ERROR;
+    }
+    return (*proc) (clientData, interp, objc, objv);
+}
+
+static int
+DataSetGetVectorPixelOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                        Tcl_Obj *const *objv)
+{
+    const char *name = Tcl_GetString(objv[5]);
+    int x, y;
+    if (Tcl_GetIntFromObj(interp, objv[3], &x) != TCL_OK ||
+        Tcl_GetIntFromObj(interp, objv[4], &y) != TCL_OK) {
+        return TCL_ERROR;
+    }
+    double value[3];
+    if (!g_renderer->getVectorValueAtPixel(name, x, y, value)) {
+        Tcl_AppendResult(interp, "Pixel out of dataset bounds or no vector data available", (char*)NULL);
+        return TCL_ERROR;
+    }
+
+    char buf[256];
+    snprintf(buf, sizeof(buf), "nv>dataset vector pixel %d %d %g %g %g %s\n", x, y,
+             value[0], value[1], value[2], name);
+
+    ssize_t bytesWritten = SocketWrite(buf, strlen(buf));
+
+    if (bytesWritten < 0) {
+        return TCL_ERROR;
+    }
+    return TCL_OK;
+}
+
+static int
+DataSetGetVectorWorldOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                        Tcl_Obj *const *objv)
+{
+    const char *name = Tcl_GetString(objv[6]);
+    double x, y, z;
+    if (Tcl_GetDoubleFromObj(interp, objv[3], &x) != TCL_OK ||
+        Tcl_GetDoubleFromObj(interp, objv[4], &y) != TCL_OK ||
+        Tcl_GetDoubleFromObj(interp, objv[5], &z) != TCL_OK) {
+        return TCL_ERROR;
+    }
+    double value[3];
+    if (!g_renderer->getVectorValue(name, x, y, z, value)) {
+        Tcl_AppendResult(interp, "Coordinate out of dataset bounds or no vector data available", (char*)NULL);
+        return TCL_ERROR;
+    }
+
+    char buf[256];
+    snprintf(buf, sizeof(buf), "nv>dataset vector world %g %g %g %g %g %g %s\n", x, y, z,
+             value[0], value[1], value[2], name);
+
+    ssize_t bytesWritten = SocketWrite(buf, strlen(buf));
+
+    if (bytesWritten < 0) {
+        return TCL_ERROR;
+    }
+    return TCL_OK;
+}
+
+static Rappture::CmdSpec dataSetGetVectorOps[] = {
+    {"pixel", 1, DataSetGetVectorPixelOp, 6, 6, "x y dataSetName"},
+    {"world", 1, DataSetGetVectorWorldOp, 7, 7, "x y z dataSetName"}
+};
+static int nDataSetGetVectorOps = NumCmdSpecs(dataSetGetVectorOps);
+
+static int
+DataSetGetVectorOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                   Tcl_Obj *const *objv)
+{
+    Tcl_ObjCmdProc *proc;
+
+    proc = Rappture::GetOpFromObj(interp, nDataSetGetVectorOps, dataSetGetVectorOps,
                                   Rappture::CMDSPEC_ARG2, objc, objv, 0);
     if (proc == NULL) {
@@ -1393,4 +1523,35 @@
         g_renderer->setUseCumulativeDataRange(false);
     } else {
+        Tcl_AppendResult(interp, "bad maprange option \"", value,
+                         "\": should be all, visible, or separate", (char*)NULL);
+        return TCL_ERROR;
+    }
+    return TCL_OK;
+}
+
+static int
+DataSetNamesOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+               Tcl_Obj *const *objv)
+{
+    std::vector<std::string> dataSets;
+    g_renderer->getDataSetNames(dataSets);
+    std::ostringstream oss;
+    size_t len = 0;
+    oss << "nv>dataset names {";
+    len += 18;
+    for (size_t i = 0; i < dataSets.size(); i++) {
+        oss << "\"" << dataSets[i] << "\"";
+        len += 2 + dataSets[i].length();
+        if (i < dataSets.size() - 1) {
+            oss << " ";
+            len++;
+        }
+    }
+    oss << "}\n";
+    len += 2;
+
+    size_t bytesWritten = SocketWrite(oss.str().c_str(), len);
+
+    if (bytesWritten < 0) {
         return TCL_ERROR;
     }
@@ -1416,12 +1577,14 @@
 
 static Rappture::CmdSpec dataSetOps[] = {
-    {"add",      1, DataSetAddOp, 6, 6, "name data follows nBytes"},
-    {"delete",   1, DataSetDeleteOp, 2, 3, "?name?"},
-    {"getvalue", 1, DataSetGetValueOp, 6, 7, "oper x y ?z? name"},
-    {"maprange", 1, DataSetMapRangeOp, 3, 3, "value"},
-    {"opacity",  1, DataSetOpacityOp, 3, 4, "value ?name?"},
-    {"scalar",   1, DataSetActiveScalarsOp, 3, 4, "scalarName ?name?"},
-    {"vector",   2, DataSetActiveVectorsOp, 3, 4, "vectorName ?name?"},
-    {"visible",  2, DataSetVisibleOp, 3, 4, "bool ?name?"}
+    {"add",       1, DataSetAddOp, 6, 6, "name data follows nBytes"},
+    {"delete",    1, DataSetDeleteOp, 2, 3, "?name?"},
+    {"getscalar", 4, DataSetGetScalarOp, 6, 7, "oper x y ?z? name"},
+    {"getvector", 4, DataSetGetVectorOp, 6, 7, "oper x y ?z? name"},
+    {"maprange",  1, DataSetMapRangeOp, 3, 3, "value"},
+    {"names",     1, DataSetNamesOp, 2, 2, ""},
+    {"opacity",   1, DataSetOpacityOp, 3, 4, "value ?name?"},
+    {"scalar",    1, DataSetActiveScalarsOp, 3, 4, "scalarName ?name?"},
+    {"vector",    2, DataSetActiveVectorsOp, 3, 4, "vectorName ?name?"},
+    {"visible",   2, DataSetVisibleOp, 3, 4, "bool ?name?"}
 };
 static int nDataSetOps = NumCmdSpecs(dataSetOps);
@@ -1476,7 +1639,13 @@
     if (objc == 4) {
         const char *name = Tcl_GetString(objv[3]);
-        g_renderer->addGlyphs(name, shape);
-    } else {
-        g_renderer->addGlyphs("all", shape);
+        if (!g_renderer->addGlyphs(name, shape)) {
+            Tcl_AppendResult(interp, "Failed to create glyphs", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addGlyphs("all", shape)) {
+            Tcl_AppendResult(interp, "Failed to create glyphs for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -1864,4 +2033,5 @@
 {
     std::vector<double> contourList;
+    double heightScale;
 
     int clistc;
@@ -1880,9 +2050,19 @@
     }
 
-    if (objc == 5) {
-        const char *name = Tcl_GetString(objv[4]);
-        g_renderer->addHeightMap(name, contourList);
-    } else {
-        g_renderer->addHeightMap("all", contourList);
+    if (Tcl_GetDoubleFromObj(interp, objv[4], &heightScale) != TCL_OK) {
+        return TCL_ERROR;
+    }
+
+    if (objc == 6) {
+        const char *name = Tcl_GetString(objv[5]);
+        if (!g_renderer->addHeightMap(name, contourList, heightScale)) {
+            Tcl_AppendResult(interp, "Failed to create heightmap", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addHeightMap("all", contourList, heightScale)) {
+            Tcl_AppendResult(interp, "Failed to create heightmap for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -1894,12 +2074,22 @@
 {
     int numContours;
+    double heightScale;
     if (Tcl_GetIntFromObj(interp, objv[3], &numContours) != TCL_OK) {
         return TCL_ERROR;
     }
-    if (objc == 5) {
-        const char *name = Tcl_GetString(objv[4]);
-        g_renderer->addHeightMap(name, numContours);
-    } else {
-        g_renderer->addHeightMap("all", numContours);
+    if (Tcl_GetDoubleFromObj(interp, objv[4], &heightScale) != TCL_OK) {
+        return TCL_ERROR;
+    }
+    if (objc == 6) {
+        const char *name = Tcl_GetString(objv[5]);
+        if (!g_renderer->addHeightMap(name, numContours, heightScale)) {
+            Tcl_AppendResult(interp, "Failed to create heightmap", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addHeightMap("all", numContours, heightScale)) {
+            Tcl_AppendResult(interp, "Failed to create heightmap for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -1907,6 +2097,6 @@
 
 static Rappture::CmdSpec heightmapAddOps[] = {
-    {"contourlist", 1, HeightMapAddContourListOp, 4, 5, "contourList ?dataSetName?"},
-    {"numcontours", 1, HeightMapAddNumContoursOp, 4, 5, "numContours ?dataSetName?"}
+    {"contourlist", 1, HeightMapAddContourListOp, 5, 6, "contourList heightscale ?dataSetName?"},
+    {"numcontours", 1, HeightMapAddNumContoursOp, 5, 6, "numContours heightscale ?dataSetName?"}
 };
 static int nHeightmapAddOps = NumCmdSpecs(heightmapAddOps);
@@ -1977,6 +2167,36 @@
 
 static int
-HeightMapContourVisibleOp(ClientData clientData, Tcl_Interp *interp, int objc, 
-                          Tcl_Obj *const *objv)
+HeightMapContourListOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                       Tcl_Obj *const *objv)
+{
+    std::vector<double> contourList;
+
+    int clistc;
+    Tcl_Obj **clistv;
+
+    if (Tcl_ListObjGetElements(interp, objv[2], &clistc, &clistv) != TCL_OK) {
+        return TCL_ERROR;
+    }
+
+    for (int i = 0; i < clistc; i++) {
+        double val;
+        if (Tcl_GetDoubleFromObj(interp, clistv[i], &val) != TCL_OK) {
+            return TCL_ERROR;
+        }
+        contourList.push_back(val);
+    }
+
+    if (objc == 4) {
+        const char *name = Tcl_GetString(objv[3]);
+        g_renderer->setHeightMapContourList(name, contourList);
+    } else {
+        g_renderer->setHeightMapContourList("all", contourList);
+    }
+    return TCL_OK;
+}
+
+static int
+HeightMapContourLineVisibleOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                              Tcl_Obj *const *objv)
 {
     bool state;
@@ -1986,7 +2206,24 @@
     if (objc == 4) {
         const char *name = Tcl_GetString(objv[3]);
-        g_renderer->setHeightMapContourVisibility(name, state);
-    } else {
-        g_renderer->setHeightMapContourVisibility("all", state);
+        g_renderer->setHeightMapContourLineVisibility(name, state);
+    } else {
+        g_renderer->setHeightMapContourLineVisibility("all", state);
+    }
+    return TCL_OK;
+}
+
+static int
+HeightMapContourSurfaceVisibleOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                                 Tcl_Obj *const *objv)
+{
+    bool state;
+    if (GetBooleanFromObj(interp, objv[2], &state) != TCL_OK) {
+        return TCL_ERROR;
+    }
+    if (objc == 4) {
+        const char *name = Tcl_GetString(objv[3]);
+        g_renderer->setHeightMapContourSurfaceVisibility(name, state);
+    } else {
+        g_renderer->setHeightMapContourSurfaceVisibility("all", state);
     }
     return TCL_OK;
@@ -2089,4 +2326,22 @@
     } else {
         g_renderer->setHeightMapEdgeWidth("all", width);
+    }
+    return TCL_OK;
+}
+
+static int
+HeightMapNumContoursOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                       Tcl_Obj *const *objv)
+{
+    int numContours;
+
+    if (Tcl_GetIntFromObj(interp, objv[2], &numContours) != TCL_OK) {
+        return TCL_ERROR;
+    }
+    if (objc == 4) {
+        const char *name = Tcl_GetString(objv[3]);
+        g_renderer->setHeightMapNumContours(name, numContours);
+    } else {
+        g_renderer->setHeightMapNumContours("all", numContours);
     }
     return TCL_OK;
@@ -2216,22 +2471,43 @@
 }
 
+static int
+HeightMapWireframeOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                     Tcl_Obj *const *objv)
+{
+    bool state;
+    if (GetBooleanFromObj(interp, objv[2], &state) != TCL_OK) {
+        return TCL_ERROR;
+    }
+    if (objc == 4) {
+        const char *name = Tcl_GetString(objv[3]);
+        g_renderer->setHeightMapWireframe(name, state);
+    } else {
+        g_renderer->setHeightMapWireframe("all", state);
+    }
+    return TCL_OK;
+}
+
 static Rappture::CmdSpec heightmapOps[] = {
-    {"add",          1, HeightMapAddOp, 4, 5, "oper value ?dataSetName?"},
-    {"colormap",     1, HeightMapColorMapOp, 3, 4, "colorMapName ?dataSetName?"},
+    {"add",          1, HeightMapAddOp, 5, 6, "oper value ?dataSetName?"},
+    {"colormap",     2, HeightMapColorMapOp, 3, 4, "colorMapName ?dataSetName?"},
+    {"contourlist",  2, HeightMapContourListOp, 3, 4, "contourList ?dataSetName?"},
     {"delete",       1, HeightMapDeleteOp, 2, 3, "?dataSetName?"},
     {"edges",        1, HeightMapEdgeVisibilityOp, 3, 4, "bool ?dataSetName?"},
     {"heightscale",  1, HeightMapHeightScaleOp, 3, 4, "value ?dataSetName?"},
     {"isolinecolor", 8, HeightMapContourLineColorOp, 5, 6, "r g b ?dataSetName?"},
-    {"isolines",     8, HeightMapContourVisibleOp, 3, 4, "bool ?dataSetName?"},
+    {"isolines",     8, HeightMapContourLineVisibleOp, 3, 4, "bool ?dataSetName?"},
     {"isolinewidth", 8, HeightMapContourLineWidthOp, 3, 4, "width ?dataSetName?"},
     {"lighting",     3, HeightMapLightingOp, 3, 4, "bool ?dataSetName?"},
     {"linecolor",    5, HeightMapLineColorOp, 5, 6, "r g b ?dataSetName?"},
     {"linewidth",    5, HeightMapLineWidthOp, 3, 4, "width ?dataSetName?"},
+    {"numcontours",  1, HeightMapNumContoursOp, 3, 4, "numContours ?dataSetName?"},
     {"opacity",      2, HeightMapOpacityOp, 3, 4, "value ?dataSetName?"},
     {"orient",       2, HeightMapOrientOp, 6, 7, "qw qx qy qz ?dataSetName?"},
     {"pos",          1, HeightMapPositionOp, 5, 6, "x y z ?dataSetName?"},
     {"scale",        1, HeightMapScaleOp, 5, 6, "sx sy sz ?dataSetName?"},
+    {"surface",      2, HeightMapContourSurfaceVisibleOp, 3, 4, "bool ?dataSetName?"},
     {"visible",      2, HeightMapVisibleOp, 3, 4, "bool ?dataSetName?"},
-    {"volumeslice",  2, HeightMapVolumeSliceOp, 4, 5, "axis ratio ?dataSetName?"}
+    {"volumeslice",  2, HeightMapVolumeSliceOp, 4, 5, "axis ratio ?dataSetName?"},
+    {"wireframe",    1, HeightMapWireframeOp, 3, 4, "bool ?dataSetName?"}
 };
 static int nHeightmapOps = NumCmdSpecs(heightmapOps);
@@ -2310,7 +2586,13 @@
     if (objc == 3) {
         const char *name = Tcl_GetString(objv[2]);
-        g_renderer->addLIC(name);
-    } else {
-        g_renderer->addLIC("all");
+        if (!g_renderer->addLIC(name)) {
+            Tcl_AppendResult(interp, "Failed to create lic", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addLIC("all")) {
+            Tcl_AppendResult(interp, "Failed to create lic for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -2574,7 +2856,13 @@
     if (objc == 3) {
         const char *name = Tcl_GetString(objv[2]);
-        g_renderer->addMolecule(name);
-    } else {
-        g_renderer->addMolecule("all");
+        if (!g_renderer->addMolecule(name)) {
+            Tcl_AppendResult(interp, "Failed to create molecule", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addMolecule("all")) {
+            Tcl_AppendResult(interp, "Failed to create molecule for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -2889,7 +3177,13 @@
     if (objc == 3) {
         const char *name = Tcl_GetString(objv[2]);
-        g_renderer->addPolyData(name);
-    } else {
-        g_renderer->addPolyData("all");
+        if (!g_renderer->addPolyData(name)) {
+            Tcl_AppendResult(interp, "Failed to create polydata", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addPolyData("all")) {
+            Tcl_AppendResult(interp, "Failed to create polydata for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -3031,4 +3325,21 @@
     } else {
         g_renderer->setPolyDataOrientation("all", quat);
+    }
+    return TCL_OK;
+}
+
+static int
+PolyDataPointSizeOp(ClientData clientData, Tcl_Interp *interp, int objc, 
+                    Tcl_Obj *const *objv)
+{
+    float size;
+    if (GetFloatFromObj(interp, objv[2], &size) != TCL_OK) {
+        return TCL_ERROR;
+    }
+    if (objc == 4) {
+        const char *name = Tcl_GetString(objv[3]);
+        g_renderer->setPolyDataPointSize(name, size);
+    } else {
+        g_renderer->setPolyDataPointSize("all", size);
     }
     return TCL_OK;
@@ -3117,5 +3428,6 @@
     {"opacity",   2, PolyDataOpacityOp, 3, 4, "value ?dataSetName?"},
     {"orient",    2, PolyDataOrientOp, 6, 7, "qw qx qy qz ?dataSetName?"},
-    {"pos",       1, PolyDataPositionOp, 5, 6, "x y z ?dataSetName?"},
+    {"pos",       2, PolyDataPositionOp, 5, 6, "x y z ?dataSetName?"},
+    {"ptsize",    2, PolyDataPointSizeOp, 3, 4, "size ?dataSetName?"},
     {"scale",     1, PolyDataScaleOp, 5, 6, "sx sy sz ?dataSetName?"},
     {"visible",   1, PolyDataVisibleOp, 3, 4, "bool ?dataSetName?"},
@@ -3144,7 +3456,13 @@
     if (objc == 3) {
         const char *name = Tcl_GetString(objv[2]);
-        g_renderer->addPseudoColor(name);
-    } else {
-        g_renderer->addPseudoColor("all");
+        if (!g_renderer->addPseudoColor(name)) {
+            Tcl_AppendResult(interp, "Failed to create pseudocolor", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addPseudoColor("all")) {
+            Tcl_AppendResult(interp, "Failed to create pseudocolor for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -3529,7 +3847,13 @@
     if (objc == 3) {
         const char *name = Tcl_GetString(objv[2]);
-        g_renderer->addStreamlines(name);
-    } else {
-        g_renderer->addStreamlines("all");
+        if (!g_renderer->addStreamlines(name)) {
+            Tcl_AppendResult(interp, "Failed to create streamlines", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addStreamlines("all")) {
+            Tcl_AppendResult(interp, "Failed to create streamlines for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
@@ -4103,7 +4427,13 @@
     if (objc == 3) {
         const char *name = Tcl_GetString(objv[2]);
-        g_renderer->addVolume(name);
-    } else {
-        g_renderer->addVolume("all");
+        if (!g_renderer->addVolume(name)) {
+            Tcl_AppendResult(interp, "Failed to create volume", (char*)NULL);
+            return TCL_ERROR;
+        }
+    } else {
+        if (!g_renderer->addVolume("all")) {
+            Tcl_AppendResult(interp, "Failed to create volume for one or more data sets", (char*)NULL);
+            return TCL_ERROR;
+        }
     }
     return TCL_OK;
Index: /trunk/packages/vizservers/vtkvis/vtkRpCubeAxesActor2D.cpp
===================================================================
--- /trunk/packages/vizservers/vtkvis/vtkRpCubeAxesActor2D.cpp	(revision 2422)
+++ /trunk/packages/vizservers/vtkvis/vtkRpCubeAxesActor2D.cpp	(revision 2423)
@@ -419,8 +419,13 @@
   this->YAxis->SetFontFactor(AxisFontFactor);
   this->YAxis->SetProperty(this->GetProperty());
-
-  this->ZAxis->GetPositionCoordinate()->SetValue(zCoords[0], zCoords[1]);
-  this->ZAxis->GetPosition2Coordinate()->SetValue(zCoords[2], zCoords[3]);
-  this->ZAxis->SetRange(zRange[0], zRange[1]);
+  if ( this->YAxisVisibility ) {
+      this->ZAxis->GetPositionCoordinate()->SetValue(zCoords[0], zCoords[1]);
+      this->ZAxis->GetPosition2Coordinate()->SetValue(zCoords[2], zCoords[3]);
+      this->ZAxis->SetRange(zRange[0], zRange[1]);
+  } else {
+      this->ZAxis->GetPositionCoordinate()->SetValue(zCoords[2], zCoords[3]);
+      this->ZAxis->GetPosition2Coordinate()->SetValue(zCoords[0], zCoords[1]);
+      this->ZAxis->SetRange(zRange[1], zRange[0]);
+  }
   this->ZAxis->SetTitle(this->Labels[zAxes]);
   this->ZAxis->SetNumberOfLabels(this->NumberOfLabels);
